<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Creating a simple experimentation XMPP client.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/post/xmpp-with-nodejs/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/post/xmpp-with-nodejs/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/post/xmpp-with-nodejs/">
  <meta property="og:title" content="XMPP With Node.js | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Creating a simple experimentation XMPP client.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2018-07-08T00:21:20-06:00">
  
  <meta property="article:modified_time" content="2018-07-08T00:21:20-06:00">
  

  

  

  <title>XMPP With Node.js | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">XMPP With Node.js</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2018-07-08 00:21:20 -0600 MDT" itemprop="datePublished">
    <time datetime="2018-07-08 00:21:20 -0600 MDT" itemprop="dateModified">
      2018-07-08
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  
  <span class="middot-divider"></span>
  <span class="article-reading-time">
    6 min read
  </span>
  

  
  
  <span class="middot-divider"></span>
  <a href="/post/xmpp-with-nodejs/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=XMPP%20With%20Node.js&amp;url=https%3a%2f%2fackso.net%2fpost%2fxmpp-with-nodejs%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fpost%2fxmpp-with-nodejs%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fpost%2fxmpp-with-nodejs%2f&amp;title=XMPP%20With%20Node.js"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fpost%2fxmpp-with-nodejs%2f&amp;title=XMPP%20With%20Node.js"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=XMPP%20With%20Node.js&amp;body=https%3a%2f%2fackso.net%2fpost%2fxmpp-with-nodejs%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      

<p>XMPP has been around for a long time at this point.  Libraries for most popular
languages exist and work quite well.  There&rsquo;s even an <a href="https://xmpp.org/about/xmpp-standards-foundation.html" target="_blank">XMPP standards
body</a> that promotes the
official libraries that they suggest based on quality.</p>

<p>The <a href="https://xmppjs.org" target="_blank">XMPP.js</a> library for JavaScript turns out to be really
good, but somehow really poorly documented. There are a couple of half-baked
examples, but I found that it still took time to get something running that
touched on some of the major features of XMPP.</p>

<p>I&rsquo;ve also been working through the 2009
<a href="http://shop.oreilly.com/product/9780596521271.do" target="_blank">XMPP</a> book from O&rsquo;Reilly,
which is mostly oriented around clients rather than technical implementations,
but is still good for understanding the theory and operations. My only wish is
that this book would also have contained instructions on setting up a Jabber
server.  It would have come in handy.</p>

<p>Anyhow, below I&rsquo;m going to do a quick walk-through of what I did to get an
<a href="https://ejabberd.im" target="_blank">ejabberd</a> server running in
<a href="https://vagrantup.com" target="_blank">Vagrant</a>, connect to it from my laptop using
<a href="https://pidgin.im" target="_blank">Pidgin</a>, and run the &ldquo;Echo Bot&rdquo; example from the XMPP book,
but using Node.js instead of Python. The Echo Bot just repeats everything you IM
to it. Nothing too fancy.</p>

<p>The GitLab repo for this project is
<a href="https://gitlab.com/jeremy.jackson/use-xmpp" target="_blank">here</a> if you don&rsquo;t want to take the
time to implement this yourself.</p>

<h2>Table of Contents</h2>
<nav id="TableOfContents">
<ul>
<li><a href="#ejabberd-in-vagrant">ejabberd in Vagrant</a>
<ul>
<li><a href="#here-s-my-vagrantfile">Here&rsquo;s my <code>Vagrantfile</code></a></li>
<li><a href="#here-s-my-setup-sh">Here&rsquo;s my <code>setup.sh</code></a></li>
</ul></li>
<li><a href="#installing-pidgin">Installing Pidgin</a></li>
<li><a href="#node-js-echo-bot">Node.js Echo Bot</a></li>
<li><a href="#running-it-all">Running it all</a></li>
<li><a href="#conclusion">Conclusion</a></li>
</ul>
</nav>


<h1 id="ejabberd-in-vagrant">ejabberd in Vagrant</h1>

<p>I ended up just setting up a quick and easy Ubuntu 16.04 server in Vagrant. I
used the <code>ejabberd</code> that was in the repo and everything went great.
With some minimal configuration and user adding in the setup script everything
runs very well.</p>

<h2 id="here-s-my-vagrantfile">Here&rsquo;s my <code>Vagrantfile</code></h2>

<p>Take special note of the forwarded ports. Port 5280 is for the web admin panel,
and port 5222 is the TCP port that ejabberd talks over. There&rsquo;s several
different protocols that you can use, like UDP, based on your own configuration.</p>

<pre><code class="language-ruby"># -*- mode: ruby -*-
# vi: set ft=ruby :

Vagrant.configure(&quot;2&quot;) do |config|
  config.vm.box = &quot;bento/ubuntu-16.04&quot;

  config.vm.network &quot;forwarded_port&quot;, guest: 5280, host: 5280, host_ip: &quot;127.0.0.1&quot;
  config.vm.network &quot;forwarded_port&quot;, guest: 5222, host: 5222, host_ip: &quot;127.0.0.1&quot;

  config.vm.provider &quot;virtualbox&quot; do |vb|
    vb.memory = &quot;1024&quot;
    vb.cpus = &quot;1&quot;
  end

  config.vm.provision &quot;shell&quot;, path: &quot;setup.sh&quot;
end
</code></pre>

<h2 id="here-s-my-setup-sh">Here&rsquo;s my <code>setup.sh</code></h2>

<p>Nothing too crazy here. The <code>sed</code> lines are just modifying some relevant
configs in <code>ejabberd</code>&rsquo;s config file.</p>

<pre><code class="language-bash">apt-get update

apt-get install -y ejabberd

# It defaults to IPv6, but I want IPv4 just to keep things simple here.
sed -i 's/    ip: &quot;::&quot;/    ip: &quot;0.0.0.0&quot;/g' /etc/ejabberd/ejabberd.yml

# This is just setting up the admin user.
sed -i 's/         - &quot;&quot;: &quot;localhost&quot;/         - &quot;admin&quot;: &quot;localhost&quot;/' /etc/ejabberd/ejabberd.yml

systemctl restart ejabberd

# I was surprised that the restart took long enough that the ejabberdctl
# commands below were failing.
sleep 5

ejabberdctl register admin localhost password
ejabberdctl register echo_bot localhost password
</code></pre>

<h1 id="installing-pidgin">Installing Pidgin</h1>

<p>Pidgin is a Jabber-compliant Instant Messaging client for Linux, MacOS, and
Windows. They also provide source code. If you&rsquo;re using MacOS, they do suggest
using <a href="https://adium.io" target="_blank">Adium</a> instead.</p>

<p>One of the best features of Pidgin (and probably Adium) is that it has an XMPP
Console that you can enable in the Plugins section of the application. That way
you can see all of the XMPP stanzas being passed between the client and server,
and you can even use it to enter raw XMPP stanzas if you so choose. It&rsquo;s
pretty rad.</p>

<p>I&rsquo;m on Debian 9, so I just used the one in the repo&rsquo;s.</p>

<pre><code class="language-bash">sudo apt-get install -y pidgin
</code></pre>

<h1 id="node-js-echo-bot">Node.js Echo Bot</h1>

<p>This simple bot will let you subscribe to its status, and in chat will repeat
everything you say. See the comments for some more details.</p>

<pre><code class="language-javascript">// Client is the actual Client class, xml is a convenience function for building
// valid XML.
const { Client, xml } = require('xmpp.js');

const client = new Client();

// Node doesn't like self-signed certificates. You could also pass this as an
// environment variable.
process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

// Here we get into the event-based actions.
// I'm logging everything so that you can see what's getting passed through at
// each of these stages. It gets pretty interesting and looking at this helped me a
// ton when doing some debugging.
client.on('error', err =&gt; console.log('ERROR:', err.toString));

client.on('status', status =&gt; console.log('STATUS:', status));

client.on('input', input =&gt; console.log('INPUT:', input));

client.on('output', output =&gt; console.log('OUTPUT:', output));

// Most of the magic happens here. You can set up all your conditions for the
// various XMPP stanzas that you receive. You can be creative with this, for
// instance you could have the bot running on a Raspberry Pi and change
// some status LED's based on the message.
client.on('stanza', stanza =&gt; {
  console.log('STANZA:', JSON.stringify(stanza.toJSON()));

  // This acts on requests from other clients to watch the status of this bot
  // so that the other client can see whether or not this bot is online.
  if (stanza.is('presence') &amp;&amp; stanza.attrs.type === 'subscribe') {
    client.send(
      xml('presence', { to: stanza.attrs.from, type: 'subscribed' })
    );
  }

  // This is doing the echoing.
  if (stanza.is('message') &amp;&amp; stanza.attrs.from !== client.jid) {
    stanza.children.forEach(child =&gt; {
      if (child.name === 'body') {
        const response = child.children.join('\n');
        client.send(
          xml('message', { to: stanza.attrs.from, type: 'chat' },
            xml('body', {}, response)
          )
        );
      }
    });
  }
});

// When the bot comes online it updates its status to let you know that it's
// ready to talk back to you.
client.on('online', jid =&gt; {
  console.log('ONLINE:', jid.toString());
  client.send(
    xml('presence', {}, 
      xml('show', {}, 'chat'),
      xml('status', {}, 'I say everything you do!'),
    )
  );
});

// This is just handling the client authentication.
client.handle('authenticate', authenticate =&gt; {
  return authenticate('echo_bot', 'password');
});

// This actually launches the server.
client
  .start('xmpp://localhost:5222')
  .catch(err =&gt; console.error('start failed', err.message));
</code></pre>

<h1 id="running-it-all">Running it all</h1>

<p>To get this whole thing running you need to first launch the vagrant box, then
create a new account in Pidgin for <code>admin@localhost</code> using the fake <code>password</code>,
and then launch the Echo Bot (<code>node index.js</code>). You&rsquo;ll see some console output from the bot
registering with the <code>ejabberd</code> server, and then it will just wait. Once it&rsquo;s
waiting, you can &ldquo;Add a Buddy&rdquo; in Pidgin, by looking for <code>echo_bot@localhost</code>.
The Echo Bot will pick that up so that you can then see its status in Pidgin.
Lastly, you can go ahead and open up a chat with your new <code>echo_bot</code> buddy, and
it will repeat everything back to you.</p>

<h1 id="conclusion">Conclusion</h1>

<p>This library has a couple of other components as well, but what they do and how
to use them I have no idea because the documentation is basically non-existent.
I&rsquo;ll be sure to update here if/when I get to those other features.</p>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/vagrant/">vagrant</a>
  
  <a class="badge badge-light" href="/tags/xmpp/">xmpp</a>
  
  <a class="badge badge-light" href="/tags/node/">node</a>
  
  <a class="badge badge-light" href="/tags/nodejs/">nodejs</a>
  
  <a class="badge badge-light" href="/tags/javascript/">javascript</a>
  
  <a class="badge badge-light" href="/tags/jabber/">jabber</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    
    <div class="article-widget">
      <div class="hr-light"></div>
      <h3>Related</h3>
      <ul>
        
        <li><a href="/project/refactoring-mock-couch/">Refactoring Mock Couch</a></li>
        
        <li><a href="/post/first-steps-with-apache-kafka/">First Steps With Apache Kafka</a></li>
        
        <li><a href="/project/exercises-for-programmers-5/">Exercises for Programmers 5 - NODEJS</a></li>
        
        <li><a href="/project/exercises-for-programmers-4/">Exercises for Programmers 4 - NODEJS</a></li>
        
        <li><a href="/project/exercises-for-programmers-3/">Exercises for Programmers 3 - NODEJS</a></li>
        
      </ul>
    </div>
    

    

    
<section id="comments">
  <div id="disqus_thread"></div>
<script type="application/javascript">
    var disqus_config = function () {
    
    
    
    };
    (function() {
        if (["localhost", "127.0.0.1"].indexOf(window.location.hostname) != -1) {
            document.getElementById('disqus_thread').innerHTML = 'Disqus comments not available by default when the website is previewed locally.';
            return;
        }
        var d = document, s = d.createElement('script'); s.async = true;
        s.src = '//' + "ackso-net.disqus.com" + '.disqus.com/embed.js';
        s.setAttribute('data-timestamp', +new Date());
        (d.head || d.body).appendChild(s);
    })();
</script>
<noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
<a href="https://disqus.com" class="dsq-brlink">comments powered by <span class="logo-disqus">Disqus</span></a>
</section>



  </div>
</article>

<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

